/*
   ADC.H
*/

#ifndef VDSP_H
#define VDSP_H

#include "windows.h"

#include "vmcad.h"

class CADC
  {
   // , 
   public:
   CADC ( LPCTSTR name );
   ~CADC ( void );

   //    

   public:
   HANDLE HVDSP;
   private:
   _CMDSTRUCT FVDSPCMD;
   public:
   int CardAccount;
   int ChannelAccount;
   DWORD BytesPost;
   int ExecCommand( DWORD Command , long BytesSend, void * OutBuf );

   // 

   public:
   int SetCard ( int card );
   int SetChannel ( int channel );

   int GetCurrentCard ( int *val );
   int GetCurrentChannel ( int *val );

   //  

   public:
   int GetBufSize ( int *val );
   int GetChWidth ( int *val );
   int GetLLD ( int *val );
   int GetULD ( int *val );
   int GetMode ( int *val );
   int GetInten ( int *val );
   int GetRealTime ( int *val );
   int GetLiveTime ( int *val );
   int GetPresetRealTime ( int *val );
   int GetPresetLiveTime ( int *val );

   int SetBufSize ( int size );
   int SetChWidth ( int chw );
   int SetLLD ( int lld );
   int SetULD ( int uld );
   int SetMode ( int mode );
   int SetRealTime ( int time );
   int SetLiveTime ( int time );
   int SetPresetRealTime ( int time );
   int SetPresetLiveTime ( int time );

   int LockCh ( void );
   int UnLockCh ( void );

   int GetCardAccount ( int *val );
   int GetChannelAccount ( int *val );
   int GetVxdVer ( int *val );
   int GetADCVer ( int *val );
   int GetStatus ( int *val );

   int ClearBuf ( void );
   int RunChannel ( void );
   int StopChannel ( void );

   int WriteEPROM ( void * p);
   int ReadEPROM  ( void * p);

   int WriteBuf ( void * p, int size );
   int ReadBuf ( void * p, int size );
};

#endif
