#include <stdio.h>
#include "adc.h"

// Name of the driver is ADCXK2.VXD ( \\.\ADCXK2 )
const char * drv_name = "\\\\.\\ADCXK2";

#define _ERROR { printf("Error: &i\n", error); return; }


void main ( void )
{
	int i, val, *buf, channel, chacc;
	int error;
	int flag;
	CADC * padc;

	try
	{
		padc=new CADC(drv_name);
	}
	catch (char * e)
	{
		printf("%s\n",e);
		return;
	}

	// To print on the screen quantity of cards
	if (error=padc->GetCardAccount(&val)) _ERROR;
	printf("Card account: %i\n",val);

	// To choose the first card
	padc->SetCard(1);

	// To print on the screen quantity of inputs on a card
	if (error=padc->GetChannelAccount(&chacc)) _ERROR;
	printf("Channel account: %i\n",chacc);

	for (channel=1; channel<=chacc; ++channel)
	{
		// To choose the input
		padc->SetChannel(channel);

		// To make capture of the channel for management by it
		if (error=padc->LockCh()) _ERROR;

		// To clean the buffer
		if (error=padc->ClearBuf()) _ERROR;

		// Mode of accumulation - " on real time "
		if (error=padc->SetMode(RealTime)) _ERROR;

		// To establish time of accumulation
		if (error=padc->SetPresetRealTime(10000*channel)) _ERROR;

		// Start of accumulation
		padc->RunChannel();
	}

	// To print the current time of accumulation
	do
	{
		flag=0;
		for (channel=1; channel<=chacc; ++channel)
		{
			// To choose the input
			padc->SetChannel(channel);

			padc->GetRealTime(&val);
			printf("| channel: %i, live time: %i ", channel, val);

			// To check up on end of accumulation in the channel
			padc->GetStatus(&val);
			flag|=val&RegimFlag;
		}
		printf("|\n");
	}
	while (flag); // To finish if all channels have stopped

	for (channel=1; channel<=chacc; ++channel)
	{
		// To choose the input
		padc->SetChannel(channel);

		// To read the size of the buffer
		if (error=padc->GetBufSize(&val)) _ERROR;

		// To read the buffer
		buf = new int[val];
		padc->ReadBuf(buf,val*sizeof(int));

		printf ("\nResults for the channel %i. =====================\n",channel);

		for (i=0; i!=val; ++i)
			printf("Channel %i, Count %i\n",i,buf[i]);

		delete buf;

		// To release the channel
		padc->UnLockCh();
	}
}