/*
	VMCAD.H

	Interface to virtual multichannel analyzer driver

    Copyright (c) 1999-2000, SPC Aspect
*/

#ifndef _VMCAD_H
#define _VMCAD_H


/*   */

struct _CMDSTRUCT {
	long CardNo;
	long ChannelNo;
	long Offset;
};

typedef struct _CMDSTRUCT CMDSTRUCT;


/*  */

#define errTooManyOpenProc    201
#define errCardNotPresent     202
#define errInvalidChannel     203
#define errInvalidOwner       204
#define errInvalidOutputSize  205
#define errNotChannelOwner    207  
#define errInvalidInputBuf    208
#define errInvalidValue       209
#define errInvalidCommand     211
#define errRegOpenERROR       212
#define errInvalidRegion      213
#define errUldLELld           214
#define errLldGEUld           215
#define errExecute            216
#define errChannelAlreadyLock 219
#define errUnsupported        220
#define errDisableChannel     221
#define errCommandFor1Ch      222 
#define errChWorked           223
#define errInvalidCLive       224
#define errInvalidCReal       225


/*   */

#define RealTime                1
#define LiveTime                2


/*   */

#define RegimFlag              	64 // RUN or STOP
#define LockFlag              	128 // Lock or Unlock


/*   */

#define cmGetBufSize            1
#define cmGetChWidth            2
#define cmGetLLD                3
#define cmGetULD                4
#define cmGetMode               5 
#define cmGetInten              6

#define cmGetRealTime           7
#define cmGetLiveTime           8
#define cmGetPresetLiveTime    32
#define cmGetPresetRealTime    33

#define cmSetBufSize            9
#define cmSetChWidth           10
#define cmSetLLD               11
#define cmSetULD               12
#define cmSetMode              13
#define cmSetPresetRealTime    14
#define cmSetPresetLiveTime    15

#define cmLockCh               16
#define cmUnLockCh             17

#define cmGetCardAccount       18
#define cmGetChannelAccount    19
#define cmGetADCVer            20
#define cmGetVxdVer            21
#define cmGetStatus            22

#define cmClearBuf             23
#define cmRunChannel           24
#define cmStopChannel          25

#define cmWriteEPROM           26
#define cmReadEPROM            27

#define cmWriteBuf             28
#define cmReadBuf              29

#define cmRestartChannel       30
#define cmGetADCUsage          31

#define cmSetRealTime          34
#define cmSetLiveTime          35


#endif
